package com.zhiLian.datasource;


import com.zhiLian.common.core.utils.StringUtils;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import static com.zhiLian.datasource.contents.DatasourceContent.*;

/**
 * @author DongZl
 * @description: 数据源实体类
 * @Date 2023-8-1 上午 11:15
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class DataSourceInfo {

    private String key;

    private String url;

    private String userName;

    private String password;


    public static DataSourceInfo databaseNameBuild(String databaseName){
        return DataSourceInfo.builder()
                .key(databaseName)
                .url(StringUtils.format(DATASOURCE_URL, databaseName))
                .password(PASSWORD)
                .userName(USER_NAME)
                .build();
    }
}
